<div class="container">
  <h1 class="header">Discover</h1>

  <mat-horizontal-stepper [linear]="isLinear" #stepper>
    <mat-step>
      <form>
        <ng-template matStepLabel>Filter</ng-template>
        <section class="content">
          <div>
            <button mat-raised-button color="primary" matStepperNext (click)="getRecommendations()">Next</button>
          </div>
          <mat-slide-toggle [(ngModel)]="autoFilter" name="autoFilter" class="auto-toggle" [disabled]="isNewUser">Auto filters</mat-slide-toggle>
          <div *ngIf="!autoFilter" class="manual-filters">
            <div>
              <h4>Get recommendations based on</h4>
              <mat-radio-group class="seed-radio-group" [(ngModel)]="seedType" name="seedType">
                <mat-radio-button *ngIf="!isNewUser" class="seed-radio-button" value="top-artists">
                  Your Top Artists
                </mat-radio-button>
                <mat-radio-button value="artist-seed">
                  <mat-form-field>
                    <input 
                      matInput 
                      placeholder="Artist" 
                      aria-label="Artist" 
                      [matAutocomplete]="artist" 
                      [(ngModel)]="selectedArtist" 
                      name="selectedArtist" 
                      (input)="onArtistSearchChange($event.target.value)">
                    <mat-autocomplete #artist="matAutocomplete" [displayWith]="displayArtistName">
                      <mat-option *ngFor="let artist of filteredArtistList" [value]="artist" >
                        <span>{{artist.name}}</span>
                      </mat-option>
                    </mat-autocomplete>
                  </mat-form-field>
                </mat-radio-button>
                <mat-radio-button value="genre-seed">
                  <mat-form-field>
                    <input 
                      matInput 
                      placeholder="Genre" 
                      aria-label="Genre" 
                      [matAutocomplete]="auto" 
                      [(ngModel)]="selectedGenre" 
                      name="selectedGenre" 
                      (input)="onGenreSearchChange()">
                    <mat-autocomplete #auto="matAutocomplete">
                      <mat-option *ngFor="let genre of filteredGenreList" [value]="genre">
                        <span>{{genre}}</span>
                      </mat-option>
                    </mat-autocomplete>
                  </mat-form-field>
                </mat-radio-button>
              </mat-radio-group>
            </div>

            <div>
              <h4>Music attributes</h4>            
              <div>
                <mat-checkbox [(ngModel)]="filterCheckboxes.danceability" name="danceability-checkbox">Danceability</mat-checkbox>
                <mat-slider 
                  matInput [(ngModel)]="filters.danceability" name="danceability" min=0 max=1 step=0.01>
                </mat-slider>
              </div>
              <div>
                <mat-checkbox [(ngModel)]="filterCheckboxes.energy" name="energy-checkbox">Energy</mat-checkbox>
                <mat-slider 
                  matInput [(ngModel)]="filters.energy" name="energy" min=0 max=1 step=0.01>
                </mat-slider>
              </div>
              <div>
                <mat-checkbox [(ngModel)]="filterCheckboxes.happiness" name="happiness-checkbox">Happiness</mat-checkbox>
                <mat-slider 
                  matInput [(ngModel)]="filters.happiness" name="happiness" min=0 max=1 step=0.01>
                </mat-slider>
              </div>
              <div>
                <mat-checkbox [(ngModel)]="filterCheckboxes.acousticness" name="acousticness-checkbox">Acousticness</mat-checkbox>
                <mat-slider 
                  matInput [(ngModel)]="filters.acousticness" name="acousticness" min=0 max=1 step=0.01>
                </mat-slider>
              </div>
              <div>
                <mat-checkbox [(ngModel)]="filterCheckboxes.popularity" name="popularity-checkbox">Popularity</mat-checkbox>
                <mat-slider 
                  matInput [(ngModel)]="filters.popularity" name="popularity" min=0 max=80 step=1>
                </mat-slider>
              </div>
            </div>
            
          </div>
        </section>
      </form>
    </mat-step>
    <mat-step>
      <form>
        <ng-template matStepLabel>Save to a playlist</ng-template>
        <div *ngIf="showList">
          <div>
            <button mat-raised-button color="primary" (click)="createPlaylist()">Save playlist</button>
            <button mat-raised-button matStepperPrevious class="back-button">Back</button>
          </div>
          <mat-list>
            <mat-list-item *ngFor="let track of recommendationList.tracks; let i = index">
              <img matListAvatar [src]="track.album.images[1].url" alt="Track cover">
              <button mat-icon-button *ngIf="!track.playingNow" class="play-button" (click)="play(track)" [disabled]="!track.preview_url">
                  <mat-icon>play_arrow</mat-icon>
              </button>
              <button mat-icon-button  *ngIf="track.playingNow" class="pause-button" (click)="pause(track)">
                  <mat-icon>pause</mat-icon>
              </button>
              <div mat-line>
                <mat-checkbox [(ngModel)]="checkList[i]" [ngModelOptions]="{standalone: true}">
                  <div class="list-line">
                    <div class="track-name">
                      <div><strong>{{ track.name | slice:0:40 }}</strong></div>
                      <div> {{ track.artists[0].name }} </div>
                    </div>
                  </div>
                </mat-checkbox>
              </div>
              <mat-divider></mat-divider>
            </mat-list-item>
          </mat-list> 
        </div>
      </form>
    </mat-step>
  </mat-horizontal-stepper>
</div>
